"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.itemFilter = void 0;
var itemFilter = function (options) {
    var namespace = options.namespace, workspace = options.workspace, host = options.host, slug = options.slug, keyword = options.keyword;
    return function (item) {
        var withNamespace = namespace ? namespace === item.namespace : true;
        var withWorkspace = workspace ? workspace === item.workspace : true;
        var withHost = host ? host === item.host : true;
        var withSlug = slug ? slug === item.slug : true;
        var withKeyword = keyword ? item.slug.includes(keyword) : true;
        return (withNamespace &&
            withWorkspace &&
            withHost &&
            withSlug &&
            withKeyword);
    };
};
exports.itemFilter = itemFilter;
