"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.linkParser = void 0;
var LINK_PATTERN = /^<(?<href>.*)>; rel="(?<rel>next|last)"$/;
var toMap = function (searchParams) {
    var map = {};
    searchParams.forEach(function (value, key) { return (map[key] = value); });
    return map;
};
var linkParser = function (link) {
    var matcher = link.trim().match(LINK_PATTERN);
    if (!matcher) {
        return;
    }
    var groups = matcher.groups || {};
    var href = groups['href'];
    var params = toMap(new URLSearchParams(new URL(href).search));
    return {
        href: href,
        rel: groups['rel'],
        params: params
    };
};
exports.linkParser = linkParser;
