"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.githubItemStream = void 0;
var axios_1 = __importDefault(require("axios"));
var lib_1 = require("../lib");
var githubItemStream = function (_a) {
    var githubUsername = _a.githubUsername, githubPersonalToken = _a.githubPersonalToken, workspace = _a.workspace, kind = _a.kind, namespace = _a.namespace, handler = _a.handler, githubItemFilter = _a.githubItemFilter;
    return __awaiter(void 0, void 0, void 0, function () {
        var client, streamUrl, execute;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    client = axios_1.default.create({
                        baseURL: "https://api.github.com",
                        auth: {
                            username: githubUsername,
                            password: githubPersonalToken
                        }
                    });
                    streamUrl = "/".concat(kind, "/").concat(namespace, "/repos");
                    execute = function (params) { return __awaiter(void 0, void 0, void 0, function () {
                        var response, items, _i, items_1, item, linkHeader, nextLinks, nextParams;
                        var _a;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    if (!params)
                                        return [2, Promise.resolve()];
                                    return [4, client.get(streamUrl, { params: params })];
                                case 1:
                                    response = _b.sent();
                                    items = response.data
                                        .filter(githubItemFilter)
                                        .map(function (_a) {
                                        var ssh_url = _a.ssh_url;
                                        return (0, lib_1.fromInput)({ urlConnection: ssh_url, workspace: workspace });
                                    })
                                        .filter(function (item) { return item !== undefined; });
                                    _i = 0, items_1 = items;
                                    _b.label = 2;
                                case 2:
                                    if (!(_i < items_1.length)) return [3, 5];
                                    item = items_1[_i];
                                    if (!item)
                                        return [3, 4];
                                    return [4, handler(item).then(function (_a) {
                                            var workspace = _a.workspace, urlConnection = _a.urlConnection;
                                            return console.info({ workspace: workspace, urlConnection: urlConnection });
                                        })];
                                case 3:
                                    _b.sent();
                                    _b.label = 4;
                                case 4:
                                    _i++;
                                    return [3, 2];
                                case 5:
                                    linkHeader = response.headers.link || '';
                                    nextLinks = linkHeader
                                        .split(',')
                                        .map(lib_1.linkParser)
                                        .filter(function (link) {
                                        return (link === null || link === void 0 ? void 0 : link.rel) === 'next';
                                    });
                                    nextParams = nextLinks.length === 1 ? (_a = nextLinks[0]) === null || _a === void 0 ? void 0 : _a.params : undefined;
                                    return [2, execute(nextParams)];
                            }
                        });
                    }); };
                    return [4, execute({})];
                case 1:
                    _b.sent();
                    return [2];
            }
        });
    });
};
exports.githubItemStream = githubItemStream;
